Page MenuHomePhabricator

[X86] improve split-stack machine BB placement
ClosedPublic

Authored by thanm on Nov 5 2018, 2:20 PM.

Details

Summary

The conditional branch created to support -fsplit-stack for X86 is
left unbiased/unhinted, resulting in less than ideal block placement:
the __morestack call block is kept on the main hot path. Bias the
branch to insure that the stack allocation block is treated as a
"cold" block during machine basic block placement.

Diff Detail

Repository
rL LLVM

Event Timeline

thanm created this revision.Nov 5 2018, 2:20 PM
thanm added a reviewer: cherry.Nov 5 2018, 2:21 PM
cherry accepted this revision.Nov 6 2018, 8:53 AM

LGTM. Thanks.

Patch description: s/idea/ideal/.

This revision is now accepted and ready to land.Nov 6 2018, 8:53 AM
thanm added a comment.Nov 7 2018, 9:08 AM

Thanks for the review. I've fixed up the header comment.

thanm updated this revision to Diff 172967.Nov 7 2018, 9:09 AM

Comment change only.

thanm edited the summary of this revision. (Show Details)Nov 7 2018, 9:10 AM
This revision was automatically updated to reflect the committed changes.